unit DelphiInfo;
{*********************************************************************}
{ Description:  Project Manager                                       }
{  Programmer:  Kevin S Gallagher     gallaghe@teleport.com           }
{    Requires:  TBrkApart component (FreeWare)                        }
{    Versions:  3 and 4 of Delphi                                     }
{    Comments:  Code works but needs polishing up                     }
{*********************************************************************}

{$I DFS.INC}  { Standard defines for all Delphi Free Stuff components }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Brkapart;

type
  TfrmDelphiReg = class(TForm)
    Panel1: TPanel;
    cmdHistoryList: TButton;
    cmdLastSession: TButton;
    cmdExitDemo: TButton;
    StatusBar1: TStatusBar;
    ListBox1: TListBox;
    cmdSetSession: TButton;
    cmdGetSearchPath: TButton;
    BrkApart1: TBrkApart;
    cmdFlushCurrentSession: TButton;
    cmdWhereIsDelphi3Installed: TButton;
    cmdCodeInSight: TButton;
    procedure cmdHistoryListClick(Sender: TObject);
    procedure cmdLastSessionClick(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListBox1KeyPress(Sender: TObject; var Key: Char);
    procedure cmdExitDemoClick(Sender: TObject);
    procedure cmdSetSessionClick(Sender: TObject);
    procedure cmdGetSearchPathClick(Sender: TObject);
    procedure cmdFlushCurrentSessionClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cmdWhereIsDelphi3InstalledClick(Sender: TObject);
    procedure cmdCodeInSightClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDelphiReg: TfrmDelphiReg;

implementation

uses DPRegstr,Global, InSightCode, Main;

{$R *.DFM}

procedure TfrmDelphiReg.cmdHistoryListClick(Sender: TObject);
var
  x:Integer;
  xList:TStringList;
begin
  ListBox1.Items.Clear;

  try
    xList := TStringList.Create;
    xList.Assign(DelphiProjects);

    ListBox1.Items.Add('Files in "reopen list"');
    //  Could have used AddStrings if not for indenting
    for x := 0 to xList.Count -1 do
      ListBox1.Items.Add('     ' + xList.Strings[x]);
    xList.Free;
  except
    ListBox1.Items.Add('Failed getting projects');
  end;

  ListBox1.Items.Add('Delphi installed');
  ListBox1.Items.Add('     ' + WhereIsDelphi);

  ListBox1.Items.Add('Use to start up Delphi');
  ListBox1.Items.Add('     ' + DelphiExe);

  ListBox1.Items.Add(GetSearchPath);
  ListBox1.ItemIndex := 0;
end;
procedure TfrmDelphiReg.cmdLastSessionClick(Sender: TObject);
var
  S:String;
begin
  S := DelphiLastSession;
  if Length(S) = 0 then
    ListBox1.Items.Add('None, possible was flushed!')
  else
    ListBox1.Items.Add(S);
  ListBox1.ItemIndex := ListBox1.Items.Count -1;
end;

procedure TfrmDelphiReg.ListBox1DblClick(Sender: TObject);
begin
{}
end;

procedure TfrmDelphiReg.ListBox1KeyPress(Sender: TObject; var Key: Char);
begin
{}
end;

procedure TfrmDelphiReg.cmdExitDemoClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmDelphiReg.cmdSetSessionClick(Sender: TObject);
var
  S:String;
  x:Integer;
begin
  x := ListBox1.ItemIndex;
  if x < 0 then exit;

  S := ListBox1.Items[x];
  if S[1] = #32 then  // Only except indented items
    if MessageDlg('Make' + #13 + '[' + Trim(S) + ']' + #13 +
      'current session?',mtConfirmation,[mbYes,mbNo],0) = IDYES then
      if not SetSession(Trim(S)) then
        ShowMessage('Failed to change Session');
end;

procedure TfrmDelphiReg.cmdGetSearchPathClick(Sender: TObject);
var
  Buf  : Array[0..255] of Char;
begin
  with BrkApart1 do begin
    BaseString := GetSearchPath;
    BreakString := ';';
    BreakApart;
  end;
  if BrkApart1.StringList.Count > 0 then begin
    with ListBox1 do begin
      Items.Add('Delphi search path strings');
      Items.AddStrings(BrkApart1.StringList);
      Items.Add('End Delphi search path');
      StrPCopy(Buf,'Delphi search path strings');
      { The following may not goto the last occurance
        if you execute this event several times     }
      ItemIndex := Perform(LB_SELECTSTRING,0,LongInt(@Buf));
    end;
  end;
end;

procedure TfrmDelphiReg.cmdFlushCurrentSessionClick(Sender: TObject);
begin
  if Question('Really flush current session from registery?') then
    if not FlushProject then
      MessageDlg('Failed to flush session',mtError,[mbOk],0);
end;

procedure TfrmDelphiReg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
  Application.OnHint  := frmMain.AppOnHint;
end;

procedure TfrmDelphiReg.cmdWhereIsDelphi3InstalledClick(Sender: TObject);
begin
  ListBox1.Items.Add(WhereIsDelphi);
end;

procedure TfrmDelphiReg.cmdCodeInSightClick(Sender: TObject);
var
  f:TfrmInSight;
begin
  f := TfrmInSight.Create(Application);

  try
    {$IFDEF DFS_DELPHI_3}
    f.BorderStyle := bsDialog ;
    {$ENDIF}
    f.ShowModal;
  finally
    f.free;
  end;
end;

procedure TfrmDelphiReg.FormCreate(Sender: TObject);
begin
  Left := Screen.ActiveForm.Left + (Screen.ActiveForm.Width div 2) -(Width div 2) ;
  Top := Screen.ActiveForm.Top + (Screen.ActiveForm.Height div 2) -(Height div 2) ;
end;

end.
