unit MyAbout;

{*****************************************************************************}
{ Author                                                                      }
{   Kevin S. Gallagher                                                        }
{                                                                             }
{ Description                                                                 }
{   A very basic "About" form to use in application were you want to view the }
{   application version information.                                          }
{                                                                             }
{ Comments                                                                    }
{   I may enchance the component if I get the urge. Also there is a define    }
{   around the FileVersion component, this is because at home I am using a    }
{   later version, only difference if the name.                               }
{                                                                             }
{*****************************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  VersInfo, comctrls,extctrls, StdCtrls;

type
  TMyAboutForm = class(TComponent)
  private
    FCaption:String ;
    FCenterOnParent: Boolean ;
  published
    property Title:string read FCaption write FCaption ;
    property CenterOnParent: Boolean read FCenterOnParent write FCenterOnParent ;
  public
     function Execute:Integer  ;
  end ;

procedure Register;

implementation


function TMyAboutForm.Execute: Integer ;
var
  TheForm : TForm ;
  ThePanel: TPanel ;
  TheButton: TButton ;
  TheListView: TListView ;
  //VersRes: TdfsVersionInfoResource ;
  VersRes: TVersionInfoResource ;
begin
  TheForm := TForm.Create(nil) ;
  TheForm.Caption := FCaption ;
  ThePanel := TPanel.Create(TheForm) ;
  TheButton := TButton.Create(ThePanel) ;
  TheListView := TListView.Create(TheForm) ;

  try
    //VersRes := TdfsVersionInfoResource.Create(TheForm) ;
    VersRes := TVersionInfoResource.Create(TheForm) ;
    TheListView.Parent := TheForm ;
    TheListView.Align := alClient ;
    VersRes.Filename := Application.ExeName ;
    VersRes.VersionListView := TheListView ;

    with TheForm do
    begin
      BorderStyle := bsDialog ;
      Width := 285 ;
      Height := 165 ;

      if CenterOnParent then
      begin
        if Screen.ActiveForm <> nil then
        begin
          Position := poDesigned ;
          Left := Screen.ActiveForm.Left + (Screen.ActiveForm.Width div 2) -(Width div 2);
          Top := Screen.ActiveForm.Top + (Screen.ActiveForm.Height div 2) -(Height div 2);
        end ;
      end else
        Position := poScreenCenter ;

    end ;

    with ThePanel do
    begin
      Parent := TheForm ;
      Align := alBottom ;
      BevelInner := bvNone ;
      BevelOuter := bvLowered ;
    end ;

    with TheButton do
    begin
      Parent := ThePanel ;
      Caption := '&Close' ;
      Left := (ThePanel.ClientWidth div 2) - TheButton.Width div 2 ;
      Top := (ThePanel.ClientHeight div 2) - TheButton.Height div 2 ;
      ModalResult := mrOk ;
      Default := True ;
    end ;

    TheForm.ShowModal ;

  finally
    TheForm.Release ;
  end ;
  Result := 0 ;
end;

procedure Register;
begin
  RegisterComponents('Samples', [TMyAboutForm]);
end;

end.
