unit ProjectsFromPackFiles;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls;

type
  TfrmProjectsInPackages = class(TForm)
    StatusBar1: TStatusBar;
    ListBox1: TListBox;
    MainMenu1: TMainMenu;
    mnuFile: TMenuItem;
    mnuExit: TMenuItem;
    mnuSelect: TMenuItem;
    procedure mnuExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mnuSelectClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmProjectsInPackages: TfrmProjectsInPackages;

implementation

uses Registry, ShellApi, ReadDpr ;

{$R *.DFM}

procedure TfrmProjectsInPackages.mnuExitClick(Sender: TObject);
begin
  Close ;
end;

procedure TfrmProjectsInPackages.FormCreate(Sender: TObject);
var
  Reg: TRegistry ;
  cKey: String ;
  cTmp: String ;
  cName: String ;
  icoIndex: word ;
  iPos: Integer ;
begin
  Reg := TRegistry.Create ;
  try
    Reg.RootKey := HKEY_CLASSES_ROOT ;
    if Reg.OpenKeyReadOnly('.dpr') then
    begin
      cKey := Reg.ReadString('') ;
      Reg.CloseKey ;
      if Reg.KeyExists(cKey + '\DefaultIcon') then
        if Reg.OpenKeyReadOnly(cKey + '\DefaultIcon') then
        begin
          cTmp := Trim(Reg.ReadString('')) ;
          Reg.CloseKey ;
        end ;
    end ;
  finally
    Reg.Free ;
  end ;

  if Length(cTmp) = 0 then exit ;

  iPos := Pos(',',cTmp) ;
  cName := Copy(cTmp,1,iPos -1) ;
  icoIndex := StrToIntDef(Trim(Copy(cTmp,iPos +1,Length(cTmp) - iPos)),1) ;
  try
    Self.Icon.Handle := ExtractAssociatedIcon(hInstance,PChar(cName),icoIndex) ;
  except
  end ;

end;

procedure TfrmProjectsInPackages.mnuSelectClick(Sender: TObject);
var
  f:TfrmMakeRead ;
begin
  if ListBox1.ItemIndex = -1 then exit ;
  
  DprToRead( ListBox1.Items.Strings[ListBox1.ItemIndex] ) ;
  f := TfrmMakeRead.Create(Self) ;
  try
    f.Top := Self.Top ;
    f.Left := Self.Left ;
    f.ShowModal ;
  finally
    f.Free ;
  end ;
end;

end.
