unit TableCreate;

interface

uses
  Windows,Dialogs,SysUtils,Messages,Classes, Graphics, MKTable,
  DB, DBTables;

procedure CreateMainDBF;
procedure CreateIndices;
procedure SetTableProperties(Mode:Boolean);
procedure AddIndices;

implementation

uses main,Global;

procedure CreateMainDBF;
begin
  frmMain.Refresh;

  { You decide if some fields should be required! }
  with frmMain do begin
    SetTableProperties(True);
    with Table1 do begin
      with FieldDefs do begin
        Clear;
        Add('Item'    ,ftAutoInc,  0,False);
        Add('Name'    ,ftString,  60,False);
        Add('Location',ftString, 150,False);
        Add('MakeFile',ftString,  50,False);
        Add('WinType' ,ftString,   2,False);
        Add('Language',ftString,  20,False);
        Add('Notes'   ,ftMemo,     0,False);
      end;
      CreateTable;
      CreateIndices;
    end;
      SetTableProperties(False);
  end;
end;

procedure CreateIndices;
begin
  with frmMain do begin
    with Table1 do begin
      SetTableProperties(True);
      with IndexDefs do begin
        Clear;
        Add('', 'Item', [ixPrimary]);
        Add('Language', 'Language', []);
        Add('ByProjectLanguage', 'MakeFile;Language', []);
        Add('ByNameLanguage', 'Name;Language', []);
      end;
    end;

    SetTableProperties(False);
    Table1.Open;
    AddIndices;
  end;
end;

procedure SetTableProperties(Mode:Boolean);
begin
  with frmMain,Table1 do begin
    Active       := False;
    TableType    := ttParadox;
    Exclusive    := Mode;
    DatabaseName := sPath;
    TableName    := MainDbf;
  end;
end;

procedure AddIndices;
begin
  frmMain.Table1.Close;
  SetTableProperties(True);
  frmMain.Table1.Open;

  with frmMain,Table1 do begin
    AddIndex('', 'Item', [ixPrimary]);
    AddIndex('ByProjectLanguage','MakeFile;Language',[ixCaseInsensitive]);
    AddIndex('Language','Language',[ixCaseInsensitive]);
    AddIndex('ByNameLanguage','Name;Language',[ixCaseInsensitive]);    
  end;
  SetTableProperties(False);
  frmMain.Table1.Open;
end;

end.
